VERSION 4.00
Begin VB.Form frmTapiLine 
   Caption         =   "Form1"
   ClientHeight    =   5595
   ClientLeft      =   645
   ClientTop       =   1620
   ClientWidth     =   10140
   Height          =   6000
   Left            =   585
   LinkTopic       =   "Form1"
   ScaleHeight     =   5595
   ScaleWidth      =   10140
   Top             =   1275
   Width           =   10260
   Begin VB.CommandButton cmdLineConfProv 
      Caption         =   "LineConfProv"
      Height          =   450
      Left            =   2580
      TabIndex        =   15
      Top             =   5040
      Width           =   1200
   End
   Begin VB.CommandButton cmdLineDeallocate 
      Caption         =   "LineDealloc"
      Height          =   450
      Left            =   7620
      TabIndex        =   14
      Top             =   4500
      Width           =   1200
   End
   Begin VB.CommandButton cmdLineGetInfo 
      Caption         =   "LineGetInfo"
      Height          =   450
      Left            =   1320
      TabIndex        =   13
      Top             =   5040
      Width           =   1200
   End
   Begin VB.CommandButton cmdLineShowHandles 
      Caption         =   "Show Handles"
      Height          =   450
      Left            =   60
      TabIndex        =   12
      Top             =   5040
      Width           =   1200
   End
   Begin VB.TextBox Text1 
      BackColor       =   &H00C0C0C0&
      BeginProperty Font 
         name            =   "MS LineDraw"
         charset         =   2
         weight          =   400
         size            =   8.25
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   3915
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   11
      Text            =   "TAPITest.frx":0000
      Top             =   420
      Width           =   9915
   End
   Begin VB.CommandButton cmdLineAbout 
      Caption         =   "TAPI About"
      Height          =   450
      Left            =   5100
      TabIndex        =   10
      Top             =   5040
      Width           =   1200
   End
   Begin VB.CommandButton cmdLineDrop 
      Caption         =   "Line Drop"
      Height          =   450
      Left            =   6360
      TabIndex        =   9
      Top             =   4500
      Width           =   1200
   End
   Begin VB.CommandButton cmdLineDialProps 
      Caption         =   "Dialing Props"
      Height          =   450
      Left            =   7620
      TabIndex        =   8
      Top             =   5040
      Width           =   1200
   End
   Begin VB.CommandButton cmdLineAddrStatus 
      Caption         =   "Addr Status"
      Height          =   450
      Left            =   3840
      TabIndex        =   7
      Top             =   5040
      Width           =   1200
   End
   Begin VB.CommandButton cmdLineConfDialog 
      Caption         =   "Config Dialog"
      Height          =   450
      Left            =   6360
      TabIndex        =   6
      Top             =   5040
      Width           =   1200
   End
   Begin VB.CommandButton cmdLineDevCaps 
      Caption         =   "Get DevCaps"
      Height          =   450
      Left            =   2580
      TabIndex        =   5
      Top             =   4500
      Width           =   1200
   End
   Begin VB.CommandButton cmdLineClose 
      Caption         =   "Close"
      Height          =   450
      Left            =   8880
      TabIndex        =   4
      Top             =   4500
      Width           =   1200
   End
   Begin VB.CommandButton cmdLineMakeCall 
      Caption         =   "Line Make Call"
      Height          =   450
      Left            =   5100
      TabIndex        =   3
      Top             =   4500
      Width           =   1200
   End
   Begin VB.CommandButton cmdLineOpen 
      Caption         =   "Line Open"
      Height          =   450
      Left            =   3840
      TabIndex        =   2
      Top             =   4500
      Width           =   1200
   End
   Begin VB.CommandButton cmdLineNegApi 
      Caption         =   "Line Neg"
      Height          =   450
      Left            =   1320
      TabIndex        =   1
      Top             =   4500
      Width           =   1200
   End
   Begin VB.CommandButton cmdLineInit 
      Caption         =   "Line Initialize"
      Height          =   450
      Left            =   60
      TabIndex        =   0
      Top             =   4500
      Width           =   1200
   End
   Begin VB.Label Label1 
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Status Messages and Call Progress:"
      Height          =   255
      Left            =   120
      TabIndex        =   16
      Top             =   120
      Width           =   9915
   End
   Begin TapilineLib.Tapiline Tapiline1 
      Left            =   9180
      Top             =   5100
      _Version        =   65536
      _ExtentX        =   529
      _ExtentY        =   529
      _StockProps     =   0
   End
End
Attribute VB_Name = "frmTapiLine"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Dim nline As Integer ' line to select
Dim lNumDev As Long ' number of devices
Dim cLine As String

Function GetVarInfo(nSize As Long, nOffset As Long, cString As String, nLen As Long) As String
    Dim cValue As String
    '
    If nSize <> 0 Then
       cValue = Mid(cString, ((nOffset - nLen - 3)), nSize)
    Else
        cValue = ""
    End If
    '
    GetVarInfo = cValue
    '
End Function

Private Sub cmdLineAbout_Click()
    '
    ' show TAPILine about box
    '
    Tapiline1.AboutBox
    '
End Sub

Private Sub cmdLineAddrStatus_Click()
    '
    ' get address status of the line
    '
    Dim udtAddr As LINEADDRESSSTATUS
    Dim c As String * 2048
    Dim lRtn As Long
    '
    ' make the call to GetAddressStatus
    lRtn = Tapiline1.LineGetAddressStatus
    If lRtn < 0 Then
        AddText Me.Text1, "<<<ERROR>>> LineGetAddressStatus..." & LineErr(lRtn)
        Exit Sub
    End If
    '
    ' get the results
    LineAddressStatusFunc TAPI_READ, udtAddr, c
    '
    ' show them to user
    AddText Me.Text1, "TotalSize..." & CStr(udtAddr.dwTotalSize)
    AddText Me.Text1, "NeededSize..." & CStr(udtAddr.dwNeededSize)
    AddText Me.Text1, "UsedSize..." & CStr(udtAddr.dwUsedSize)
    AddText Me.Text1, "NumInUse..." & CStr(udtAddr.dwNumInUse)
    AddText Me.Text1, "NumActiveCalls..." & CStr(udtAddr.dwNumActiveCalls)
    AddText Me.Text1, "NumOnHoldCalls..." & CStr(udtAddr.dwNumOnHoldCalls)
    AddText Me.Text1, "NumOnHoldPendCalls..." & CStr(udtAddr.dwNumOnHoldPendCalls)
    AddText Me.Text1, "AddressFeatures..." & CStr(udtAddr.dwAddressFeatures)
    AddText Me.Text1, "NumRingsNoAnswer..." & CStr(udtAddr.dwNumRingsNoAnswer)
    AddText Me.Text1, "ForwardNumEntries..." & CStr(udtAddr.dwForwardNumEntries)
    '
    AddText Me.Text1, cLine ' msg separator
    '
End Sub

Private Sub cmdLineClose_Click()
    '
    ' close open line
    '
    Dim a As Long
    '
    a = Tapiline1.LineClose
    If a < 0 Then
        AddText Me.Text1, "<<<ERROR>>> LineClose..." & LineErr(a)
    Else
        AddText Me.Text1, "Line Close Successful"
    End If
    '
    Me.Tapiline1.LineHandle = 0 ' clear line handle
    '
    AddText Me.Text1, cLine ' msg separator
    '
End Sub

Private Sub cmdLineConfDialog_Click()
    '
    ' show config dialog(s)
    '
    Dim a As Long
    Dim n As Integer
    Dim x As Integer
    Dim y As Integer
    Dim z As Integer
    '
    ' get a device from user
    n = InputBox("Enter Device # (-1 for all):")
    '
    ' set loop params
    If n = -1 Then
        ' user wants them all!
        y = 0
        z = lNumDev - 1
    Else
        ' user just wants one
        y = n
        z = n
    End If
    '
    ' call up dialog(s)
    For x = y To z
        a = Tapiline1.LineConfigDialog(x, Me.hWnd, "comm")
        If a <> 0 Then
            MsgBox LineErr(a), vbCritical, "lineConfigDialog Error!"
        End If
    Next x
    '
End Sub

Private Sub cmdLineConfProv_Click()
    '
    ' call provider's config
    '
    Dim lRtn As Long
    '
    Tapiline1.PermanentProviderID = InputBox("Enter PermProviderID:")
    AddText Me.Text1, "PermProvider..." & CStr(Tapiline1.PermanentProviderID)
    lRtn = Tapiline1.LineConfigProvider(Me.hWnd)
    If lRtn < 0 Then
        AddText Me.Text1, "<<<ERROR>>> LineConfigProvider..." & LineErr(lRtn)
    Else
        AddText Me.Text1, "LineConfigProvider successfull"
    End If
    '
    AddText Me.Text1, cLine ' msg separator
    '
End Sub

Private Sub cmdLineDeallocate_Click()
    '
    ' de-allocate memory from unused line
    '
    Dim lRtn As Long
    '
    lRtn = Tapiline1.LineDeallocateCall
    If lRtn < 0 Then
        AddText Me.Text1, "<<<ERROR>>> LineDeallocateCall..." & LineErr(lRtn)
    Else
        AddText Me.Text1, "LineDeallocateCall Successful"
    End If
    '
    Me.Tapiline1.HandleToCall = 0 ' clear call handle
    '
    AddText Me.Text1, cLine ' msg separator
    '
End Sub

Private Sub cmdLineDevCaps_Click()
    '
    ' display capabilites of each line
    '
    Dim a As Long
    Dim b As LINEDEVCAPS
    Dim c As String * 2048
    Dim x As Integer
    '
    Dim nSize As Long
    Dim nOffset As Long
    Dim cValue As String
    '
    For x = 0 To lNumDev - 1
        ' make the call to get dev caps
        a = Tapiline1.LineGetDevCaps(x)
        If a < 0 Then
          AddText Me.Text1, "<<<ERROR>>> DevCaps..." & LineErr(a)
        End If
        ' read the results
        LineDevCapsFunc TAPI_READ, b, c
        '
        ' strip out non-printables
        c = Clean(c)
        '
        ' show user device capabilities
        AddText Me.Text1, "Line Device #" & CStr(x)
        AddText Me.Text1, "TerminalCaps..." & GetVarInfo(b.dwTerminalCapsSize, b.dwTerminalCapsOffset, c, Len(b))
        AddText Me.Text1, "ProviderInfo..." & GetVarInfo(b.dwProviderInfoSize, b.dwProviderInfoOffset, c, Len(b))
        AddText Me.Text1, "TerminalText..." & GetVarInfo(b.dwTerminalTextSize, b.dwTerminalTextOffset, c, Len(b))
        AddText Me.Text1, "DevSpecific..." & GetVarInfo(b.dwDevSpecificSize, b.dwDevSpecificOffset, c, Len(b))
        AddText Me.Text1, "LineName..." & GetVarInfo(b.dwLineNameSize, b.dwLineNameOffset, c, Len(b))
        AddText Me.Text1, "TotalSize..." & CStr(b.dwTotalSize)
        AddText Me.Text1, "NeededSize..." & CStr(b.dwNeededSize)
        AddText Me.Text1, "UsedSize..." & CStr(b.dwUsedSize)
        AddText Me.Text1, "MaxNumActiveCalls..." & CStr(b.dwMaxNumActiveCalls)
        AddText Me.Text1, cLine ' msg separator
    Next x
    '
End Sub

Private Sub cmdLineDialProps_Click()
    '
    ' show the dialing properties dialog
    '
    Dim lReturn As Long
    Dim nDevice As Integer
    Dim x As Integer
    '
    ' get device from user
    nDevice = InputBox("Enter Device # (-1 for all):")
    If nDevice <> -1 Then
        ' user wants just one
        lReturn = Tapiline1.LineTranslateDialog(nDevice, Me.hWnd, "")
        If lReturn <> 0 Then
            MsgBox LineErr(lReturn), vbCritical, "LineTranslateDialog Error!"
        End If
    Else
        ' show them all to user
        For x = 0 To lNumDev - 1
            lReturn = Tapiline1.LineTranslateDialog(x, Me.hWnd, "")
            If lReturn <> 0 Then
                MsgBox LineErr(lReturn), vbCritical, "LineTranslateDialog Error!"
            End If
        Next x
    End If
    '
End Sub

Private Sub cmdLineDrop_Click()
    '
    ' drop idle line
    '
    Dim lRtn As Long
    '
    lRtn = Tapiline1.LineDrop("", 0)
    If lRtn < 0 Then
        AddText Me.Text1, "<<<ERROR>>> LineDrop..." & LineErr(lRtn)
    Else
        AddText Me.Text1, "LineDrop Successful"
    End If
    '
    AddText Me.Text1, cLine ' msg separator
    '
End Sub

Private Sub cmdLineGetInfo_Click()
    '
    ' get lots of info on this line
    '
    LocalGetLineInfo
    '
End Sub

Private Sub cmdLineInit_Click()
    '
    ' initialize TAPI interface'
    '
    Dim a As Long
    '
    a = Me.Tapiline1.LineInitialize("TAPITEST")
    If a < 0 Then
      AddText Me.Text1, "<<<ERROR>>> LineInit..." & LineErr(a)
    End If
    '
    lNumDev = Tapiline1.NumDevices
    AddText Me.Text1, "LineInit (NumDev: " & CStr(lNumDev) & ")"
    '
    AddText Me.Text1, cLine ' msg separator
    '
End Sub

Private Sub cmdLineMakeCall_Click()
    '
    ' make a real call
    '
    Dim a As Long
    Dim b As LINECALLPARAMS
    Dim c As String * 2048
    Dim cAddress As String
    '
    ' read current parameters
    LineCallParamsFunc TAPI_READ, b, c
    '
    ' show them to the user
    AddText Me.Text1, "TotalSize..." & CStr(b.dwTotalSize)
    AddText Me.Text1, "BearerMode..." & CStr(b.dwBearerMode)
    AddText Me.Text1, "MinRate..." & CStr(b.dwMinRate)
    AddText Me.Text1, "MaxRate..." & CStr(b.dwMaxRate)
    AddText Me.Text1, "MediaMode..." & CStr(b.dwMediaMode)
    AddText Me.Text1, "CallParamFlags..." & CStr(b.dwCallParamFlags)
    AddText Me.Text1, "AddressMode..." & CStr(b.dwAddressMode)
    AddText Me.Text1, "AddressID..." & CStr(b.dwAddressID)
    '
    ' get phone number to dial
    cAddress = InputBox("Enter Address to Dial:", "Dialing String")
    '
    ' make the call
    a = Me.Tapiline1.LineMakeCall(cAddress, 1)
    If a < 0 Then
        AddText Me.Text1, "<<<ERROR>>> LineMakeCall..." & LineErr(a)
    End If
    '
    AddText Me.Text1, cLine ' message separator
    '
End Sub

Private Sub cmdLineNegApi_Click()
    '
    ' get api info for all devices
    '
    Dim a As Long
    Dim x As Integer
    '
    For x = 0 To lNumDev - 1
        a = Me.Tapiline1.LineNegotiateAPIVersion(x, 65536, 65540)
        If a < 0 Then
            AddText Me.Text1, "<<<ERROR>>> LineNegAPI..." & LineErr(a)
        Else
            AddText Me.Text1, "LineNegAPI... Dev #" & CStr(x) & " OK"
        End If
    Next x
    '
    AddText Me.Text1, cLine ' msg separator
    '
End Sub

Private Sub cmdLineOpen_Click()
    '
    ' open a selected line
    ' and show results
    '
    Dim a As Long
    Dim b As LINECALLPARAMS
    Dim c As String * 2048
    Dim s As String
    Dim cValue As String
    '
    ' get line number from user
    nline = InputBox("Enter Line to Open:")
    '
    ' perform the open
    a = Me.Tapiline1.LineOpen(nline, 0, LINECALLPRIVILEGE_NONE, LINEMEDIAMODE_INTERACTIVEVOICE)
    If a < 0 Then
      AddText Me.Text1, "<<<ERROR>>> LineOpen..." & LineErr(a)
    End If
    '
    ' get parameters
    FillCallParams ' prep area first
    LineCallParamsFunc TAPI_READ, b, c ' then read it
    '
    ' show them to user
    AddText Me.Text1, "TotalSize..." & CStr(b.dwTotalSize)
    AddText Me.Text1, "BearerMode..." & CStr(b.dwBearerMode)
    AddText Me.Text1, "MinRate..." & CStr(b.dwMinRate)
    AddText Me.Text1, "MaxRate..." & CStr(b.dwMaxRate)
    AddText Me.Text1, "MediaMode..." & CStr(b.dwMediaMode)
    AddText Me.Text1, "CallParamFlags..." & CStr(b.dwCallParamFlags)
    AddText Me.Text1, "AddressMode..." & CStr(b.dwAddressMode)
    AddText Me.Text1, "AddressID..." & CStr(b.dwAddressID)
    AddText Me.Text1, "OrigAddressSize..." & CStr(b.dwOrigAddressSize)
    AddText Me.Text1, "OrigAddressOffset..." & CStr(b.dwOrigAddressOffset)
    AddText Me.Text1, "Originating Address..." & GetOffset(Len(b), b.dwOrigAddressOffset, b.dwOrigAddressSize, c)
    '
    AddText Me.Text1, cLine ' msg separator
    '
End Sub

Private Sub cmdLineShowHandles_Click()
    '
    ' show handle properties
    '
    ShowHandles
    '
End Sub


Private Sub Form_Load()
    Text1 = ""
    Me.Caption = "TAPILine Test Form"
    '
    Me.Left = (Screen.Width - Me.Width) / 2
    Me.Top = (Screen.Height - Me.Height) / 2
    '
    cLine = String(80, 45) ' for message box
    '
    ClearHandles ' clear out control handles
    '
End Sub

Private Sub Form_Unload(Cancel As Integer)
    '
    ' be sure to close the line before leaving
    '
    Dim a As Long
    a = Tapiline1.LineClose
    '
End Sub

Public Sub LocalGetLineInfo()
    '
    ' get the line information
    '
    Dim cp As LINECALLINFO
    Dim cpx As String * 2048
    Dim lRtn As Long
    '
    ' make API call
    lRtn = Tapiline1.LineGetCallInfo
    If lRtn < 0 Then
        AddText Me.Text1, "<<<ERROR>>> LineGetCallInfo..." & LineErr(lRtn)
        Exit Sub
    End If
    '
    ' check results
    LineCallInfoFunc TAPI_READ, cp, cpx
    '
    ' strip out non-printables
    cpx = Clean(cpx)
    '
    ' show it to user
    LineCallInfoShow Me.Text1, cp, cpx
    '
End Sub

Private Sub Tapiline1_TapiCallBack(ByVal hDevice As Long, ByVal dwMessage As Long, ByVal dwInstance As Long, ByVal dwParam1 As Long, ByVal dwParam2 As Long, ByVal dwParam3 As Long)
    '
    ' send all messages to generic handler
    '
    Dim cMsg As String
    '
    cMsg = TapiCallBackHandler(hDevice, dwMessage, dwInstance, dwParam1, dwParam2, dwParam3)
    AddText Me.Text1, cMsg
    '
    AddText Me.Text1, cLine ' msg separator
    '
End Sub

Public Sub FillCallParams()
    '
    ' set up call params data
    '
    Dim cp As LINECALLPARAMS
    Dim cpx As String
    Dim cAddress As String
    cAddress = "555-1212" ' pretend this is your phone number
    '
    cp.dwBearerMode = LINEBEARERMODE_VOICE
    cp.dwMinRate = 9.6
    cp.dwMaxRate = 28.8
    cp.dwMediaMode = LINEMEDIAMODE_DATAMODEM
    cp.dwCallParamFlags = 0
    cp.dwAddressMode = LINEADDRESSMODE_DIALABLEADDR
    cp.DialParams.dwDialPause = 0
    cp.DialParams.dwDialSpeed = 0
    cp.DialParams.dwDigitDuration = 0
    cp.DialParams.dwWaitForDialtone = 0
    cp.dwOrigAddressSize = Len(cAddress)
    cp.dwOrigAddressOffset = Len(cp)
    cp.dwCalledPartySize = 0
    cp.dwCommentSize = 0
    cp.dwUserUserInfoSize = 0
    cp.dwHighLevelCompSize = 0
    cp.dwLowLevelCompSize = 0
    cp.dwDevSpecificSize = 0
    '
    cpx = cAddress
    cp.dwTotalSize = Len(cp) + Len(cpx)
    LineCallParamsFunc TAPI_WRITE, cp, cpx
    '
End Sub

Public Sub ShowHandles()
    '
    AddText Me.Text1, "LineApp (Session)......" & Hex(Tapiline1.LineApp)
    AddText Me.Text1, "LineHandle (Line)......" & Hex(Tapiline1.LineHandle)
    AddText Me.Text1, "HandleToCall (Call)...." & Hex(Tapiline1.HandleToCall)
    AddText Me.Text1, "AddressID (internal)..." & Hex(Tapiline1.AddressID)
    '
    AddText Me.Text1, cLine ' msg separator
    '
End Sub

Public Sub ClearHandles()
    '
    ' set all control handles to zero
    '
    Me.Tapiline1.LineApp = 0
    Me.Tapiline1.LineHandle = 0
    Me.Tapiline1.HandleToCall = 0
    Me.Tapiline1.AddressID = 0
    '
End Sub

